2023-02-16 03:16:57

by Lu Wei

[permalink] [raw]
Subject: [PATCH net,v2,0/2] Fix a fib6 info notification bug

This patch set fixes a length calculation bug in fib6 info notification
and adds two testcases.

The test reult is listed as follows:

before the fix patch:

Fib6 info length calculation in route notify test
TEST: ipv6 route add notify [FAIL]

Fib4 info length calculation in route notify test
TEST: ipv4 route add notify [ OK ]

after the fix patch:

Fib6 info length calculation in route notify test
TEST: ipv6 route add notify [ OK ]

Fib4 info length calculation in route notify test
TEST: ipv4 route add notify [ OK ]


Lu Wei (2):
ipv6: Add lwtunnel encap size of all siblings in nexthop calculation
selftests: fib_tests: Add test cases for IPv4/IPv6 in route notify

net/ipv6/route.c | 11 +--
tools/testing/selftests/net/fib_tests.sh | 92 +++++++++++++++++++++++-
2 files changed, 97 insertions(+), 6 deletions(-)

--
2.31.1



2023-02-16 03:17:00

by Lu Wei

[permalink] [raw]
Subject: [PATCH net,v2,1/2] ipv6: Add lwtunnel encap size of all siblings in nexthop calculation

In function rt6_nlmsg_size(), the length of nexthop is calculated
by multipling the nexthop length of fib6_info and the number of
siblings. However if the fib6_info has no lwtunnel but the siblings
have lwtunnels, the nexthop length is less than it should be, and
it will trigger a warning in inet6_rt_notify() as follows:

WARNING: CPU: 0 PID: 6082 at net/ipv6/route.c:6180 inet6_rt_notify+0x120/0x130
......
Call Trace:
<TASK>
fib6_add_rt2node+0x685/0xa30
fib6_add+0x96/0x1b0
ip6_route_add+0x50/0xd0
inet6_rtm_newroute+0x97/0xa0
rtnetlink_rcv_msg+0x156/0x3d0
netlink_rcv_skb+0x5a/0x110
netlink_unicast+0x246/0x350
netlink_sendmsg+0x250/0x4c0
sock_sendmsg+0x66/0x70
___sys_sendmsg+0x7c/0xd0
__sys_sendmsg+0x5d/0xb0
do_syscall_64+0x3f/0x90
entry_SYSCALL_64_after_hwframe+0x72/0xdc

This bug can be reproduced by script:

ip -6 addr add 2002::2/64 dev ens2
ip -6 route add 100::/64 via 2002::1 dev ens2 metric 100

for i in 10 20 30 40 50 60 70;
do
ip link add link ens2 name ipv_$i type ipvlan
ip -6 addr add 2002::$i/64 dev ipv_$i
ifconfig ipv_$i up
done

for i in 10 20 30 40 50 60;
do
ip -6 route append 100::/64 encap ip6 dst 2002::$i via 2002::1
dev ipv_$i metric 100
done

ip -6 route append 100::/64 via 2002::1 dev ipv_70 metric 100

This patch fixes it by adding nexthop_len of every siblings using
rt6_nh_nlmsg_size().

Fixes: beb1afac518d ("net: ipv6: Add support to dump multipath routes via RTA_MULTIPATH attribute")
Signed-off-by: Lu Wei <[email protected]>
---
net/ipv6/route.c | 11 ++++++-----
1 file changed, 6 insertions(+), 5 deletions(-)

diff --git a/net/ipv6/route.c b/net/ipv6/route.c
index e74e0361fd92..a6983a13dd20 100644
--- a/net/ipv6/route.c
+++ b/net/ipv6/route.c
@@ -5540,16 +5540,17 @@ static size_t rt6_nlmsg_size(struct fib6_info *f6i)
nexthop_for_each_fib6_nh(f6i->nh, rt6_nh_nlmsg_size,
&nexthop_len);
} else {
+ struct fib6_info *sibling, *next_sibling;
struct fib6_nh *nh = f6i->fib6_nh;

nexthop_len = 0;
if (f6i->fib6_nsiblings) {
- nexthop_len = nla_total_size(0) /* RTA_MULTIPATH */
- + NLA_ALIGN(sizeof(struct rtnexthop))
- + nla_total_size(16) /* RTA_GATEWAY */
- + lwtunnel_get_encap_size(nh->fib_nh_lws);
+ rt6_nh_nlmsg_size(nh, &nexthop_len);

- nexthop_len *= f6i->fib6_nsiblings;
+ list_for_each_entry_safe(sibling, next_sibling,
+ &f6i->fib6_siblings, fib6_siblings) {
+ rt6_nh_nlmsg_size(sibling->fib6_nh, &nexthop_len);
+ }
}
nexthop_len += lwtunnel_get_encap_size(nh->fib_nh_lws);
}
--
2.31.1


2023-02-16 03:17:02

by Lu Wei

[permalink] [raw]
Subject: [PATCH net,v2,2/2] selftests: fib_tests: Add test cases for IPv4/IPv6 in route notify

Add tests to check whether the total fib info length is calculated
corretly in route notify process.

Signed-off-by: Lu Wei <[email protected]>
---
tools/testing/selftests/net/fib_tests.sh | 92 +++++++++++++++++++++++-
1 file changed, 91 insertions(+), 1 deletion(-)

diff --git a/tools/testing/selftests/net/fib_tests.sh b/tools/testing/selftests/net/fib_tests.sh
index 5637b5dadabd..4e48154bd195 100755
--- a/tools/testing/selftests/net/fib_tests.sh
+++ b/tools/testing/selftests/net/fib_tests.sh
@@ -9,7 +9,7 @@ ret=0
ksft_skip=4

# all tests in this script. Can be overridden with -t option
-TESTS="unregister down carrier nexthop suppress ipv6_rt ipv4_rt ipv6_addr_metric ipv4_addr_metric ipv6_route_metrics ipv4_route_metrics ipv4_route_v6_gw rp_filter ipv4_del_addr ipv4_mangle ipv6_mangle ipv4_bcast_neigh"
+TESTS="unregister down carrier nexthop suppress ipv6_notify ipv4_notify ipv6_rt ipv4_rt ipv6_addr_metric ipv4_addr_metric ipv6_route_metrics ipv4_route_metrics ipv4_route_v6_gw rp_filter ipv4_del_addr ipv4_mangle ipv6_mangle ipv4_bcast_neigh"

VERBOSE=0
PAUSE_ON_FAIL=no
@@ -655,6 +655,94 @@ fib_nexthop_test()
cleanup
}

+fib6_notify_test()
+{
+ setup
+
+ echo
+ echo "Fib6 info length calculation in route notify test"
+ set -e
+
+ for i in 10 20 30 40 50 60 70;
+ do
+ $IP link add dummy$i type dummy
+ $IP link set dev dummy$i up
+ $IP -6 addr add 2002::$i/64 dev dummy$i
+ done
+
+ for i in 10 20 30 40 50 60;
+ do
+ $IP -6 route append 100::/64 encap ip6 dst 2002::$i via \
+ 2002::1 dev dummy$i metric 100
+ done
+
+ set +e
+
+ $NS_EXEC ip monitor route 2> errors.txt &
+
+ $IP -6 route append 100::/64 via 2002::1 dev dummy70 metric 100
+
+ err=`cat errors.txt |grep "Message too long"`
+ if [ -z "$err" ];then
+ ret=0
+ else
+ ret=1
+ fi
+
+ log_test $ret 0 "ipv6 route add notify"
+
+ { kill %% && wait %%; } 2>/dev/null
+
+ rm errors.txt
+
+ cleanup &> /dev/null
+}
+
+
+fib_notify_test()
+{
+ setup
+
+ echo
+ echo "Fib4 info length calculation in route notify test"
+
+ set -e
+
+ for i in 10 20 30 40 50 60 70;
+ do
+ $IP link add dummy$i type dummy
+ $IP link set dev dummy$i up
+ $IP addr add 192.168.100.$i/24 dev dummy$i
+ done
+
+ for i in 10 20 30 40 50 60;
+ do
+ $IP route append 10.0.0.0/24 encap ip dst 192.168.100.$i via \
+ 192.168.100.1 dev dummy$i metric 100
+ done
+
+ $NS_EXEC ip monitor route 2> errors.txt &
+
+ set +e
+
+ $IP route append 10.0.0.0/24 via 192.168.100.1 dev dummy70 metric 100
+
+ err=`cat errors.txt |grep "Message too long"`
+ if [ -z "$err" ];then
+ ret=0
+ else
+ ret=1
+ fi
+
+ log_test $ret 0 "ipv4 route add notify"
+
+ { kill %% && wait %%; } 2>/dev/null
+
+ rm errors.txt
+
+ cleanup &> /dev/null
+}
+
fib_suppress_test()
{
echo
@@ -2109,6 +2197,8 @@ do
fib_carrier_test|carrier) fib_carrier_test;;
fib_rp_filter_test|rp_filter) fib_rp_filter_test;;
fib_nexthop_test|nexthop) fib_nexthop_test;;
+ fib_notify_test|ipv4_notify) fib_notify_test;;
+ fib6_notify_test|ipv6_notify) fib6_notify_test;;
fib_suppress_test|suppress) fib_suppress_test;;
ipv6_route_test|ipv6_rt) ipv6_route_test;;
ipv4_route_test|ipv4_rt) ipv4_route_test;;
--
2.31.1


2023-02-16 05:45:15

by David Ahern

[permalink] [raw]
Subject: Re: [PATCH net,v2,1/2] ipv6: Add lwtunnel encap size of all siblings in nexthop calculation

On 2/15/23 9:26 PM, Lu Wei wrote:
> In function rt6_nlmsg_size(), the length of nexthop is calculated
> by multipling the nexthop length of fib6_info and the number of
> siblings. However if the fib6_info has no lwtunnel but the siblings
> have lwtunnels, the nexthop length is less than it should be, and
> it will trigger a warning in inet6_rt_notify() as follows:
>
> WARNING: CPU: 0 PID: 6082 at net/ipv6/route.c:6180 inet6_rt_notify+0x120/0x130
> ......
> Call Trace:
> <TASK>
> fib6_add_rt2node+0x685/0xa30
> fib6_add+0x96/0x1b0
> ip6_route_add+0x50/0xd0
> inet6_rtm_newroute+0x97/0xa0
> rtnetlink_rcv_msg+0x156/0x3d0
> netlink_rcv_skb+0x5a/0x110
> netlink_unicast+0x246/0x350
> netlink_sendmsg+0x250/0x4c0
> sock_sendmsg+0x66/0x70
> ___sys_sendmsg+0x7c/0xd0
> __sys_sendmsg+0x5d/0xb0
> do_syscall_64+0x3f/0x90
> entry_SYSCALL_64_after_hwframe+0x72/0xdc
>
> This bug can be reproduced by script:
>
> ip -6 addr add 2002::2/64 dev ens2
> ip -6 route add 100::/64 via 2002::1 dev ens2 metric 100
>
> for i in 10 20 30 40 50 60 70;
> do
> ip link add link ens2 name ipv_$i type ipvlan
> ip -6 addr add 2002::$i/64 dev ipv_$i
> ifconfig ipv_$i up
> done
>
> for i in 10 20 30 40 50 60;
> do
> ip -6 route append 100::/64 encap ip6 dst 2002::$i via 2002::1
> dev ipv_$i metric 100
> done
>
> ip -6 route append 100::/64 via 2002::1 dev ipv_70 metric 100
>
> This patch fixes it by adding nexthop_len of every siblings using
> rt6_nh_nlmsg_size().
>
> Fixes: beb1afac518d ("net: ipv6: Add support to dump multipath routes via RTA_MULTIPATH attribute")
> Signed-off-by: Lu Wei <[email protected]>
> ---
> net/ipv6/route.c | 11 ++++++-----
> 1 file changed, 6 insertions(+), 5 deletions(-)
>

Reviewed-by: David Ahern <[email protected]>



2023-02-16 05:52:22

by David Ahern

[permalink] [raw]
Subject: Re: [PATCH net,v2,2/2] selftests: fib_tests: Add test cases for IPv4/IPv6 in route notify

On 2/15/23 9:26 PM, Lu Wei wrote:
> diff --git a/tools/testing/selftests/net/fib_tests.sh b/tools/testing/selftests/net/fib_tests.sh
> index 5637b5dadabd..4e48154bd195 100755
> --- a/tools/testing/selftests/net/fib_tests.sh
> +++ b/tools/testing/selftests/net/fib_tests.sh
> @@ -9,7 +9,7 @@ ret=0
> ksft_skip=4
>
> # all tests in this script. Can be overridden with -t option
> -TESTS="unregister down carrier nexthop suppress ipv6_rt ipv4_rt ipv6_addr_metric ipv4_addr_metric ipv6_route_metrics ipv4_route_metrics ipv4_route_v6_gw rp_filter ipv4_del_addr ipv4_mangle ipv6_mangle ipv4_bcast_neigh"
> +TESTS="unregister down carrier nexthop suppress ipv6_notify ipv4_notify ipv6_rt ipv4_rt ipv6_addr_metric ipv4_addr_metric ipv6_route_metrics ipv4_route_metrics ipv4_route_v6_gw rp_filter ipv4_del_addr ipv4_mangle ipv6_mangle ipv4_bcast_neigh"
>
> VERBOSE=0
> PAUSE_ON_FAIL=no
> @@ -655,6 +655,94 @@ fib_nexthop_test()
> cleanup
> }
>
> +fib6_notify_test()
> +{
> + setup
> +
> + echo
> + echo "Fib6 info length calculation in route notify test"
> + set -e
> +
> + for i in 10 20 30 40 50 60 70;
> + do
> + $IP link add dummy$i type dummy
> + $IP link set dev dummy$i up
> + $IP -6 addr add 2002::$i/64 dev dummy$i
> + done
> +
> + for i in 10 20 30 40 50 60;
> + do
> + $IP -6 route append 100::/64 encap ip6 dst 2002::$i via \
> + 2002::1 dev dummy$i metric 100
> + done

That creates a multipath route because of a quirk with IPv6. It would be
better to make this explicit by

nexthops=
for i in 10 20 30 40 50 60;
do
nexthops="$nexthops nexthop encap ip6 dst 2002::$i via 2002::1 dev
dummy$i metric 100"
done

$IP -6 route add 100::/64 ${nexthops}

> +
> +fib_notify_test()
> +{
> + setup
> +
> + echo
> + echo "Fib4 info length calculation in route notify test"
> +
> + set -e
> +
> + for i in 10 20 30 40 50 60 70;
> + do
> + $IP link add dummy$i type dummy
> + $IP link set dev dummy$i up
> + $IP addr add 192.168.100.$i/24 dev dummy$i
> + done
> +
> + for i in 10 20 30 40 50 60;
> + do
> + $IP route append 10.0.0.0/24 encap ip dst 192.168.100.$i via \
> + 192.168.100.1 dev dummy$i metric 100
> + done

With IPv4 that is not a multipath route but a series of independent
routes. Hence, doing the loop here like I showed above makes sure this
is a proper multipath route.

Thank you for adding the tests.